Bug 1587998 - Update to 2.24 breaks keyboard layouts in XWayland applications when having several keyboard layouts enabled
Summary: Update to 2.24 breaks keyboard layouts in XWayland applications when having s...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: xorg-x11-xkb-utils
Version: 28
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: X/OpenGL Maintenance List
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2018-06-06 12:50 UTC by Christian Stadelmann
Modified: 2018-06-28 12:17 UTC (History)
18 users (show)

Fixed In Version: xorg-x11-xkb-utils-7.7-25.fc28
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2018-06-09 20:43:06 UTC
Type: Bug


Attachments (Terms of Use)


Links
System ID Private Priority Status Summary Last Updated
Red Hat Bugzilla 1589008 0 unspecified CLOSED Regression with 2.24: XKB_DEFAULT_OPTIONS not interpreted properly as with 2.23 2021-02-22 00:41:40 UTC

Internal Links: 1589008

Description Christian Stadelmann 2018-06-06 12:50:30 UTC
Description of problem:
A regression in version 2.24 causes unexpected keyboard layout changes in a multi-keyboard-layout setup under GNOME/Wayland.

Version-Release number of selected component (if applicable):
xkeyboard-config-2.24-1.fc28.noarch is broken
xkeyboard-config-2.23.1-1.fc28.noarch works fine

How reproducible:
always on my machine/keyboard layout setup

Steps to Reproduce:
0. update xkeyboard-config to 2.24
1. log in to a GNOME+Wayland session
2. start any XWayland application, e.g. `GDK_BACKEND=x11 gedit`
3. type anything
4. start any pure wayland application, e.g. `gedit`

Actual results:
Wrong keyboard on step 2, correct keyboard layout on 4. This is reproducible for all applications, including firefox.

Expected results:
keyboard layout must be the same for wayland and XWayland applications. XWayland keyboard layout must be the keyboard layout I configured.

Additional info:
$ localectl 
   System Locale: LANG=de_DE.UTF-8
       VC Keymap: de-neo
      X11 Layout: de,de,us
     X11 Variant: neo,nodeadkeys,

My keyboard layouts are:
de-neo (German Neo2; the default), de nodeadkeys (default german keyboard layout), us

The update: https://bodhi.fedoraproject.org/updates/FEDORA-2018-45800254e5

Comment 1 Łukasz Faber 2018-06-06 22:22:10 UTC
I have the same issue with xkeyboard-config-2.24-1.fc28.noarch and:

$ localectl 
   System Locale: LANG=en_US.UTF-8
                  LC_NUMERIC=pl_PL.UTF-8
                  LC_TIME=pl_PL.UTF-8
                  LC_MONETARY=pl_PL.UTF-8
                  LC_PAPER=pl_PL.UTF-8
                  LC_MEASUREMENT=pl_PL.UTF-8
       VC Keymap: pl
      X11 Layout: pl

Comment 2 Peter Hutterer 2018-06-06 23:47:11 UTC
I think this one fixes it, but i'm not quite sure yet why it only affects XWayland. Can you please give this a test?

https://koji.fedoraproject.org/koji/taskinfo?taskID=27463675

Comment 3 Peter Hutterer 2018-06-07 04:07:04 UTC
Ok, this turned out to be an issue in xkbcomp, but triggered by the additions in xkeyboard-config 0.24. Fix coming up.

Comment 4 Fedora Update System 2018-06-07 04:26:50 UTC
xorg-x11-xkb-utils-7.7-25.fc28 has been submitted as an update to Fedora 28. https://bodhi.fedoraproject.org/updates/FEDORA-2018-2d182a2b08

Comment 5 Fedora Update System 2018-06-07 04:31:55 UTC
xkeyboard-config-2.24-2.fc28 has been submitted as an update to Fedora 28. https://bodhi.fedoraproject.org/updates/FEDORA-2018-ab743936f1

Comment 6 Peter Hutterer 2018-06-07 04:34:11 UTC
Either of the above will fix the issue. The real fix is in xorg-x11-xkb-utils but let's revert the two patches that matter in xkeyboard-config in the meantime until the xkbcomp fix has been in stable for a while. Unfortunately there is no direct dependency we can introduce here through RPM.

Comment 7 Fedora Update System 2018-06-07 13:18:28 UTC
xorg-x11-xkb-utils-7.7-25.fc28 has been pushed to the Fedora 28 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2018-2d182a2b08

Comment 8 Fedora Update System 2018-06-07 13:18:35 UTC
xkeyboard-config-2.24-2.fc28 has been pushed to the Fedora 28 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2018-ab743936f1

Comment 9 Fedora Update System 2018-06-09 20:43:06 UTC
xorg-x11-xkb-utils-7.7-25.fc28 has been pushed to the Fedora 28 stable repository. If problems still persist, please make note of it in this bug report.

Comment 10 Fedora Update System 2018-06-09 20:43:13 UTC
xkeyboard-config-2.24-2.fc28 has been pushed to the Fedora 28 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.